/*
 * Created on 2007/01/10
 *
 *
 * Copyright(c) 2007 Yoshimasa Matsumoto
 */
package netjfwatcher.provision.nodemaneger.list;

import java.util.Iterator;
import java.util.Map;

import netjfwatcher.common.view.AbstractTableView;
import netjfwatcher.provision.command.core.LoggingProvision;
import netjfwatcher.provision.command.schedule.ProvisionCommandTaskPreference;
import netjfwatcher.provision.command.schedule.ProvisionCommandTaskScheduleControl;
import netjfwatcher.provision.command.schedule.ProvisionCommandTaskScheduleInfo;
import netjfwatcher.provision.info.ProvisionInfoControl;
import netjfwatcher.provision.model.action.ProvisionStartStopStatus;

import org.eclipse.swt.widgets.Display;

/**
 * Provisionf[^i[L[IɊĎAe[u\NX łB
 * 
 * @author Yoshimasa Matsumoto
 * @version 1.0
 */
public class ProvisionTableTimerProcessor extends AbstractTableView implements
		Runnable {
	/** ProvisionML[Ď(ms) */
	public static final int TIMER = 1000;

	/* Display */
	private Display display;

	private ProvisionNodeListTableView provisionTableView;

	/**
	 * TrapMf[^i[L[IɊĎAe[u\ NXCX^X𐶐܂B
	 */
	public ProvisionTableTimerProcessor() {
		// nothing
	}

	/**
	 * ProvisionML[IɊĎAL[Ƀf[^ꍇɂ f[^PopProvisione[uɕ\܂B
	 * 
	 */
	public void run() {
		if (provisionTableView != null
				&& !provisionTableView.getViewer().getTable().isDisposed()
				&& provisionTableView.getViewer().getTable().getVisible()) {
			/*
			 * ProvisionL[Ď
			 */
			String message = ProvisionMessageQueue.getInstance()
					.popPortScanInfo();

			while (message != null) {

				provisionTableView.setProvisionTableListView(true);
				message = ProvisionMessageQueue.getInstance().popPortScanInfo();
			}
		}
		if (ProvisionStartStopStatus.getInstance().isRunProvision()) {
			checkCompleteProvision();
		}
		// ^C}[p
		display.timerExec(TIMER, this);
	}

	private void checkCompleteProvision() {

		Map provisionMap = ProvisionInfoControl.getInstance()
				.getProvisionInfoHashMap();

		Map taskScheduleMap = ProvisionCommandTaskScheduleControl.getInstance()
				.getTaskScheduleMap();

		Iterator it = null;
		for (it = provisionMap.keySet().iterator(); it.hasNext();) {
			String provisionIDKey = (String) it.next();
			ProvisionCommandTaskScheduleInfo taskScheduleInfo = (ProvisionCommandTaskScheduleInfo) taskScheduleMap
					.get(provisionIDKey);

			if (taskScheduleInfo == null) {
				continue;
			}

			if (taskScheduleInfo.getProvisionInfo().getCommandResult().equals(
					ProvisionCommandTaskPreference.STATUS_WAIT)) {
				return;
			}

		}

		LoggingProvision.getInstance().stopLog();
		ProvisionStartStopStatus.getInstance().setRunProvision(false);

	}

	/**
	 * ̃NX̃CX^XԂ܂B<BR>
	 * iNXێĂVOgEIuWFNg Ԃ܂j<BR>
	 * 
	 * @return VOgEIuWFNgƂĂ̂̃NX CX^X
	 */
	public static ProvisionTableTimerProcessor getInstance() {
		return SingletonResource.RESOURCE;
	}

	/**
	 * TimersDisplayZbg܂B
	 * 
	 * @param display
	 *            TimersDisplay
	 */
	public void setDisplay(Display display) {
		this.display = display;
	}

	/**
	 * XVe[uViewZbg܂B
	 * 
	 * @param provisionTableView
	 *            XVe[uView
	 */
	public void setTable(ProvisionNodeListTableView provisionTableView) {
		this.provisionTableView = provisionTableView;
	}

	protected void setResizedTableColumnWidth() {
	}

	/**
	 * VOgEIuWFNgێNXłB<BR>
	 * 
	 */
	private static class SingletonResource {
		static final ProvisionTableTimerProcessor RESOURCE = new ProvisionTableTimerProcessor();
	}
}
